package culture;
import java.util.*;
// In the following, a program construct is on the left, and what it refers to is on the right.
// The items on the right should be translated, if they are not already.
public class InteractTexts_de_DE extends ListResourceBundle {
  static final Object[][] contents = {
        { "copyright", "Java Interact 2,  2001, David Heise." },
        { "sentenceSeparation", ". " },
        { "clauseSeparation", ", " },
        { "colon", ":" },
        { "space", " " },
        { "comma", "," },
        { "point", "." },
        { "tab", "\t" },
        { "leftBracket", "[" },
        { "rightBracket", "]" },
        { "paragraphCommand", "\n" },
        { "continuing", "Continuing with " },
        { "helpType", new String[] {"Hilfe", "Einleitung", "Kulturen", "Interagierende", "Situation definieren", "Interaktion definieren",
                "Interaktion analysieren", "Wrter finden", "Emotionen und Rollen", "Selbst explorieren", "Interact Gleichungen",
                "Simulationsergebnisse", "Im- und Exportieren", "Einstellungen"}},
// The next item, helpURL, should not be translated.
       { "helpURL", new String[] {"", "Introduction.html", "Cultures.html", "Interactants.html", "Situation.html", "Events.html",
                "Analyzing.html", "Concepts.html", "Emotions.html", "Selves.html", "Equations.html", "Report.html",
                "Import.html", "Options.htm"}},
        { "operationType", new String[] {"Einstellungen", "Interaktionsteilnehmer benennen", "Selbst explorieren", "Situation definieren", "Interaktion definieren", "Interaktion analysieren",
                                    "Wrter finden", "Emotionen und Rollen", "Gleichungen ansehen", "Eintrge importieren", "Ergebnisprotokoll"}},
        { "displayType", new String[] {"Basisfunktionen", "Fortgeschrittene Funktionen"}},
// The next item, cultureType, should not be translated.
        { "cultureType", new String[] {"Indiana 2003", "Texas 1998", "North Carolina 1978", "Ontario Canada 1981", "Ontario Canada 2001",
                "N. Ireland 1977", "Germany 1989", "Japan 1989-2002", "China-PRC 1991", "Deutsch Germany", "Deutsch Germany07"}},
        { "evaluation", "E" },
        { "potency", "P" },
        { "activity", "A" },
        { "namingLabel", "Name" },
        { "biologyLabel", "Geschlecht" },
        { "languageLabel", "Sprache" },
        { "controllingLabel", "Controlling" },
        { "personText", "Person " },
        { "selfText", "Selbst" },
        { "named", "genannt" },
        { "raterSex", "Geschlecht der Rater" },
        { "viewer", "Fr Beobachter" },
        { "male", "mnnlich" },
        { "female", "weiblich" },
        { "theSettingIs", "in der Situation" },
        { "thePersonIs", "ist" },
        { "institution", "Institution" },
        { "combination", "Kombination" },
        { "actor", "Akteur" },
        { "behavior", "Handlung" },
        { "object", "Objektperson" },
        { "obj", "Objektperson" },
        { "setting", "Kontext" },
        { "prior", "Benutze vorherige Handlungen" },
        { "unfoldOptimal", "Automatische dyadische Interaktion" },
        { "insert", "Diese Handlung implementieren" },
        { "behaviorMeaning", new String[] {"Kein wiederholendes Verhalten","Bedeutung des Verhaltens beibehalten","Bedeutung des Verhaltens verndert sich"}},
        { "experiences", "Wahrnehmung von" },
        { "actorEmotions", "Emotionen des Akteurs" },
        { "objectEmotions", "Emotionen der Objektperson" },
        { "actorBehaviors", "Optimale Handlung des Akteurs" },
        { "present", "momentanes" },
        { "future", "kommendes" },
        { "objectBehaviors", "Erwartete Reaktion der Objektperson" },
        { "actorAttributes", "Attribute des Akteurs" },
        { "objectAttributes", "Attribute der Objektperson" },
        { "actorLabels", "Wer wrde sich so verhalten" },
        { "objectLabels", "Wen wrde man so behandeln" },
        { "changeFiltersButton", "Filter" },
        { "emptyResults", "Keine annhernde Beschreibung vorhanden" },
        { "EPAprofile", "Suche Eintrge mit dem EPA Profil" },
        { "cutoffInstruction", "Maximale Entfernung angeben" },
        { "caseNames", new String[] {"Identitten", "Handlungen", "Persnlichkeit / Emotionen", "Situationen"} },
        { "identityFilters", new String[] {"Mnnlich", "Weiblich", "Privat", "Wirtschaft", "Recht", "Politik", "Universitt", "Medizin", "Religion", "Familie", "", "Selbstbezogen", "Interaktiv", "Krperlich"} },
        { "behaviorFilters", new String[] {"offen", "vermutet", "Privat", "Geschftlich", "Recht", "Politik", "Universitt", "Medizin", "Religion", "Familie", "", "Selbstbezogen", "Interaktiv", "Krperlich"} },
        { "modifierFilters", new String[] {"Adjektive", "", "Emotionen", "Persnlichkeit", "Status", "Sonstige", "", "", "", "", "", "", "", ""} },
        { "settingFilters", new String[] {"Ort", "Zeit", "Privat", "Wirtschaft", "Recht", "Politik", "Universitt", "Medizin", "Religion", "Familie", "", "Selbstbezogen", "Interaktiv", "Krperlich"} },
        { "allFilters", "Alle" },
        { "settingTitle", "Situation" },
        { "fundamental", "Grundgefhl" },
        { "transient", "Vorbergehend" },
        { "equations", new String[] {"Whlen Sie ein Gleichungssystem.", "Mnnlich Akteur-Handlung-Objektperson", "Weiblich Akteur-Handlung-Objektperson", "Mnnlich Akteur-Handlung-Objektperson-Kontext", "Weiblich Akteur-Handlung-Objektperson-Kontext", "Mnnlich selbstbezogene Handlung", "Weiblich selbstbezogene-Handlung", "Mnnlich Persnlichkeit-Identitt", "Weiblich Persnlichkeit-Identitt", "Mnnlich Emotion-Identitt", "Weiblich Emotion-Identitt"} },
        { "importEquationCoefficientsButton", "Die unteren Koeffizienten importieren" },
        { "maleRaters", "Daten von Mnnern" },
        { "femaleRaters", "Daten von Frauen" },
        { "solveFor", "Auflsen nach:" },
        { "actorIdentity", "Identitt des Akters" },
        { "objectIdentity", "Identitt der Objektperson" },
        { "actorMood", "Stimmung des Akteurs" },
        { "objectMood", "Stimmung der Objektperson" },
        { "characteristicEmotion", "Charakteristische Emotion"},
        { "givenActor", "Identitt des Akteurs" },
        { "givenObject", "Identitt der Objektperson" },
        { "actorSelf", "Selbst des Akteurs" },
        { "objectSelf", "Selbst der Objektperson" },
        { "thisBehavior", "Handlung" },
        { "compute", "Lsung berechnen" },
        { "individualAmalgamation", "Verschmolzener Affekt" },
        { "individualTransient", "Vorbergehender Affekt" },
        { "selfProfile", "EPA Selbst" },
        { "divergenceProfile", "Abweichendes EPA-Profil" },
        { "boundsTitle", "Bounds" },
        { "actualizingList", "Selbst-aktualisierende Identitten" },
        { "circuitingList", "Umgebende Identitten" },
        { "redeemingList", "Redeeming Identities" },
        { "distantList", "Andere mgliche Identitten" },
        { "writeTo", "Write To"},
        { "javaConsole", "Java Console"},
        { "processing", "Processing"},
        { "sentimentFormation", "Eindrucksbildung"},
        { "searchCutoff", "Search cut-off distance"},
        { "interactantsN", "Zahl der Interagierenden"},
        { "rememberN", "Number of events to remember"},
        { "impressions", "Fundamentals, impressions"},
        { "deflections", "Deflections"},
        { "actorEmotions", "Actor emotions"},
        { "objectEmotions", "Object emotions"},
        { "actorBehaviors", "Actor behaviors"},
        { "objectBehaviors", "Object behaviors"},
        { "actorLabels", "Actor labels"},
        { "objectLabels", "Object labels"},
        { "actorAttributes", "Actor attributes"},
        { "objectAttributes", "Object attributes"},
        { "chart", "Chart"},
        { "lists", "Lists"},
        { "verbalEvents", "Verbal events"},
        { "batchRuns", "Run events automatically"},
        { "keepRecords", "Record all events"},
        { "fromReidents", "From reidentifications"},
        { "fromTransients", "From transients"},
        { "eventProblemTitle", "Problem" },
        { "storeEventsError", new String[] {"Name des Akteurs nicht erkannt.", "Akteur hat keine Identitt.", "Die Identitt des Akterus ist nicht im Wrterbuch.", "Charakterzge / Emotionen des Akteurs sind nicht im Wrterbuch.", "Handlungen sind nicht im Wrterbuch.", "Name der Objektperson nicht erkannt.", "Objektperson hat keine Identitt.", "Die Identitt der Objektperson ist nicht im Wrterbuch.", "Charakterzge / Emotionen der Objektperson sind nicht im Wrterbuch.", "Zuviele Wrter in einer Zeile.", "Unbekanntes Zeichen.", "Zeile unvollstndig."} },
        { "empty", "_" },
        { "ok", "Okay" },
        { "earlierEvent", "Die vorhergehende Handlung muss implementiert werden." },
        { "isNot", "Fehler, die Handlung ist noch nicht implementiert" },
        { "deflection", "Deflection" },
        { "noEvents", "Keine Vorflle." },
        { "clickEvent", "Klicken Sie die erste Handlung an." },
        { "inputs", " Eingabe" },
        { "outcomes", " Ergebnisse" },
        { "filters", "Filter" },
        { "filterButton", "Weiter" },
        { "emotions", "Emotionen" },
        { "traits", "Charakterzge" },
        { "actorRoles", "Rolle des Akteurs" },
        { "objectRoles", "Rolle der Objektperson" },
        { "behaviors", "Handlungen" },
        { "responses", "Reaktionen" },
        { "filterProblemTitle", "Probleme mit dem Filter" },
        { "noEvent", "Um die Filter zu sehen, muss erst eine Handlung gewhlt werden." },
        { "missingFilter", "In einer der Spalten ist nichts ausgewhlt." },
        { "filterMsg1", "Whlen Sie eine Kategorie fr diese Begriffe." },
        { "filterMsg2", "Whlen Sie mindestens eine blaue Option, falls vorhanden," },
        { "filterMsg3", "und mindestens eine schwarze Option in jeder Spalte." },
        { "resultsHeader", "Zusammenfassung der Ergebnisse." },
        { "realResponses", "Die beabsichtigte Reaktion der Objektperson" },
        { "equationImportProblemTitle", "Probleme die Gleichungen zu importieren" },
        { "missingTerm", "Fehlender Teil in der Gleichung:" },
        { "modifierIdentityError", "Fehler in den Charakterzge/Emotionen-Identitts Interaktionen." },
        { "notBasic", "Diese Funktion funktioniert nur im Fortgeschrittenen-Modus." },
        { "PosEval", "Angenehm, Gut" },
        { "PosPotn", "Gross, Schwer" },
        { "PosActiv", "Bewegt, Schnell" },
        { "NegEval", "Unangenehm, Schlecht" },
        { "NegPotn", "Klein, Leicht" },
        { "NegActiv", "Ruhig, Langsam" },
        { "infinitely", "extrem" },
        { "extremely", "sehr" },
        { "quite", "ziemlich" },
        { "slightly", "leicht" },
        { "neutral", "neutral" },
        { "termsOfUse", "Nutzungsbedingungen beachten! Alle Rechte vorbehalten: http://www.indiana.edu/~socpsy/ACT/legal.htm" },
        { "dicIdentities", " Lexikon der Identitten, N=" },
        { "dicBehaviors", " Lexikon der Handlungen, N=" },
        { "dicModifiers", " Lexikon der Charakterzge / Emotionen, N=" },
        { "dicSettings", " Lexikon der Situationen, N=" },
        { "dicMeans", "mnnliche EPA Durchschnitte, weibliche EPA Durchschnitte:" },
        { "dicVars", "Varianz der mnnlichen EPA Werte, Varianz der weiblichen EPA Werte:" },
        { "inputButton", "Eintrge importieren (siehe unten)" },
        { "exportButton", "Momentane Eintrge anzeigen" },
        { "eraseData", "Momentane Eintrge lschen" },
        { "numberProblemTitle", "Number problem" },
        { "numberProblem", "Need a decimal number." },
        { "dicImportProblem", "Importieren Sie das Problem" },
        { "countProblem", "Falsche Anzahl von Ausdrcken in einer Zeile." },
        { "badCharacters", "Falsche Zeichen irgendwo." },
        { "historyProblem", "Zu viele Interaktionen." }
  };

  public Object[][] getContents() {
    return contents;
  }
}